module signal_6(
    clk     ,
    rst_n   ,
    din_vld ,
    din     ,
    cnt_vld ,
    cnt       
    );

    //
    parameter      DATA_W =         8;

    //źŶ
    input               clk    ;
    input               rst_n  ;
    input               din_vld;
    input [DATA_W-1:0]  din    ;

    //źŶ
    output              cnt_vld;
    output[DATA_W-1:0]  cnt    ;

    //źreg
    reg                 cnt_vld;
    reg                 cnt_vld_tmp;
    reg   [DATA_W-1:0]  cnt    ;
    reg   [DATA_W-1:0]  cnt_tmp    ;

    //cnt_vld_tmp
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            cnt_vld_tmp <= 0;
        end
        else if(din_vld || (din>=3 && din<=8) || (din>=123 && din <=130)) begin
            cnt_vld_tmp <= 1;
        end
		  else begin
		      cnt_vld_tmp <= 0;
		  end
    end

    //cnt_vld
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            cnt_vld <= 0;
        end
        else begin
            cnt_vld <= cnt_vld_tmp;
        end
    end


    //cnt_tmp
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            cnt_tmp <= 0;
        end
        else if(din_vld || (din>=3 && din<=8) || (din>=123 && din <=130)) begin
            cnt_tmp <= cnt_tmp + 1;
        end
    end

    //cnt
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            cnt <= 0;
        end
        else if(cnt_tmp==123 || cnt_tmp==215) begin
            cnt <= cnt_tmp + 1;
        end
        else begin
            cnt <= cnt_tmp;
        end
    end

endmodule

